function [a_hat,c,d] = a_hat(x1,m)

    n = length(x1);
    if size(m,1) == 1
        m = m';
    end
    x1 = abs(x1);                       % a_hat for all x: |x| 
    x1 = x1(all(~isnan(x1),2),:);       % pack out nan's

    x_ord = sort(x1,'descend');

    a_inv = zeros(size(m,1),size(m,2));
    c = zeros(size(m,1),size(m,2));
    d = zeros(size(m,1),size(m,2));

        % compute a_hat 
    for i = 1:size(m,1)
        for j = 1:size(m,2)
            if m(i,j) > 0 &&  m(i,j) < n-1
                a_inv(i,j) = mean(log(abs(x_ord(1:m(i,j),1))))-log(abs(x_ord(m(i,j)+1,1)));
                c(i,j) = x_ord(m(i,j),1);
                d(i,j) =  (m(i,j)/n)*(c(i,j)^(1/a_inv(i,j)));
            else
            	continue;
            end
        end
    end

    a_hat = 1./a_inv;

    end
